Public Class Form1
    ' Validate the TextBox's contents.
    Private Sub TextBox1_Validating(ByVal sender As Object, _
     ByVal e As System.ComponentModel.CancelEventArgs) _
     Handles TextBox1.Validating, TextBox2.Validating, TextBox3.Validating
        ' Validate the control's value.
        ValidateFiveDigits(DirectCast(sender, TextBox))
    End Sub

    ' Verify that the TextBox contains five digits.
    Private Sub ValidateFiveDigits(ByVal text_box As TextBox)
        ' See if the data is valid.
        If (text_box.Text.Length <> 0) And _
            Not (text_box.Text Like "#####") _
        Then
            ' Invalid. Set an error.
            ErrorProvider1.SetError(text_box, _
                text_box.Name & " must contain exactly five digits")
        Else
            ' Valid. Clear the error.
            ErrorProvider1.SetError(text_box, "")
        End If
    End Sub

    ' See if any fields have error messages.
    Private Sub Form1_FormClosing(ByVal sender As Object, _
     ByVal e As System.Windows.Forms.FormClosingEventArgs) _
     Handles Me.FormClosing
        ' Assume we will cancel the close.
        e.Cancel = True

        ' Check for errors.
        If IsInvalidField(TextBox1) Then Exit Sub
        If IsInvalidField(TextBox3) Then Exit Sub

        ' If we got this far, the data's okay.
        e.Cancel = False
    End Sub

    ' If this control has an error message assigned to it,
    ' display the message, set focus to the control,
    ' and return True.
    Private Function IsInvalidField(ByVal ctl As Control) As Boolean
        ' See if the control has an associated error message.
        If ErrorProvider1.GetError(ctl).Length = 0 Then
            ' No error message.
            Return False
        Else
            ' There is an error message.
            ' Display the message.
            MessageBox.Show(ErrorProvider1.GetError(ctl))

            ' Set focus to the control.
            ctl.Focus()
            Return True
        End If
    End Function
End Class
