Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim emp_list As New EmployeeCollection
        emp_list.Add(New Employee("Ann", "Anderson"))
        emp_list.Add(New Employee("Bart", "Baskerville"))
        emp_list.Add(New Employee("Candy", "Cant"))
        emp_list.Add(New Employee("Durk", "Distant"))
        emp_list.Add(New Employee("Edwina", "Evers"))

        For Each emp As Employee In emp_list
            Debug.WriteLine(emp.ToString)
        Next emp

        Me.Close()
    End Sub
End Class

Public Class Employee
    Private m_FirstName As String
    Private m_LastName As String
    Public Sub New(ByVal first_name As String, ByVal last_name As String)
        m_FirstName = first_name
        m_LastName = last_name
    End Sub
    Public Overrides Function ToString() As String
        Return m_FirstName & " " & m_LastName
    End Function
End Class

' A strongly typed collection of Employees.
Public Class EmployeeCollection
    Inherits CollectionBase

    ' Add an Employee.
    Public Sub Add(ByVal value As Employee)
        List.Add(value)
    End Sub

    ' Return True if the collection contains this employee.
    Public Function Contains(ByVal value As Employee) As Boolean
        Return List.Contains(value)
    End Function

    ' Return this Employee's index.
    Public Function IndexOf(ByVal value As Employee) As Integer
        Return List.IndexOf(value)
    End Function

    ' Insert a new Employee.
    Public Sub Insert(ByVal index As Integer, ByVal value As Employee)
        List.Insert(index, value)
    End Sub

    ' Return the Employee at this position.
    Default Public ReadOnly Property Item(ByVal index As Integer) As Employee
        Get
            Return DirectCast(List.Item(index), Employee)
        End Get
    End Property

    ' Remove an Employee.
    Public Sub Remove(ByVal value As Employee)
        List.Remove(value)
    End Sub
End Class
