Imports System.Drawing.Drawing2D

Public Class Form1
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        ' Draw the target rectangle.
        Dim device_rect As New Rectangle(50, 50, 150, 150)
        'Dim device_rect As New Rectangle(50, 50, 50, 150)
        'Dim device_rect As New Rectangle(50, 200, 150, -150)
        e.Graphics.DrawRectangle(Pens.Black, device_rect)

        ' Map between world and device coordinate rectangles.
        Dim world_rect As New Rectangle(0, 0, 1, 1)
        MapRectangles(e.Graphics, world_rect, device_rect)

        ' Draw the smiley face.
        DrawSmiley(e.Graphics)
    End Sub

    ' Draw a smiley face in the rectangle 
    ' 0 <= X <= 1, 0 <= Y <= 1.
    Private Sub DrawSmiley(ByVal gr As Graphics)
        Dim the_pen As New Pen(Color.Black, 0)
        gr.FillEllipse(Brushes.Yellow, 0, 0, 1, 1)              ' Face.
        gr.DrawEllipse(the_pen, 0, 0, 1, 1)
        gr.DrawArc(the_pen, 0.2, 0.2, 0.6, 0.6, 0, 180)         ' Smile.
        gr.FillEllipse(Brushes.Black, 0.4, 0.4, 0.2, 0.25)      ' Nose
        gr.FillEllipse(Brushes.White, 0.25, 0.15, 0.2, 0.25)    ' Left eye.
        gr.DrawEllipse(the_pen, 0.25, 0.15, 0.2, 0.25)
        gr.FillEllipse(Brushes.Black, 0.35, 0.2, 0.1, 0.15)
        gr.FillEllipse(Brushes.White, 0.55, 0.15, 0.2, 0.25)    ' Right eye.
        gr.DrawEllipse(the_pen, 0.55, 0.15, 0.2, 0.25)
        gr.FillEllipse(Brushes.Black, 0.65, 0.2, 0.1, 0.15)
    End Sub

    ' Map a world coordinate rectangle to a device coordinate rectangle.
    Private Sub MapRectangles(ByVal gr As Graphics, ByVal world_rect As Rectangle, ByVal device_rect As Rectangle)
        ' Reset the transformation.
        gr.ResetTransform()

        ' Translate to center the world coordinate 
        ' rectangle at the origin.
        gr.TranslateTransform( _
            CSng(-(world_rect.X + world_rect.Width / 2)), _
            CSng(-(world_rect.Y + world_rect.Height / 2)), _
            MatrixOrder.Append)

        ' Scale.
        gr.ScaleTransform( _
            CSng(device_rect.Width / world_rect.Width), _
            CSng(device_rect.Height / world_rect.Height), _
            MatrixOrder.Append)

        ' Translate to move the origin to the center 
        ' of the device coordinate rectangle.
        gr.TranslateTransform( _
            CSng(device_rect.X + device_rect.Width / 2), _
            CSng(device_rect.Y + device_rect.Height / 2), _
            MatrixOrder.Append)
    End Sub
End Class
