Imports System.Drawing.Drawing2D

Public Class Form1
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        Dim y As Integer = 10
        Dim x As Integer = 10
        Dim wid As Integer = 200
        Dim hgt As Integer = 50

        ' Make a rectangle that shades from black to white.
        e.Graphics.DrawString("Simple", Me.Font, Brushes.Black, x, y)
        y += 15
        Dim black_white_brush As New _
            LinearGradientBrush( _
                New Point(x, y), New Point(x + wid, y), _
                Color.Black, Color.White)
        e.Graphics.FillRectangle(black_white_brush, _
            x, y, wid, hgt)
        y += hgt + 10

        ' ColorBlend.
        e.Graphics.DrawString("ColorBlend", Me.Font, Brushes.Black, x, y)
        y += 15
        Dim color_blend As New ColorBlend(3)
        color_blend.Colors = New Color() {Color.Black, Color.White, Color.Black}
        color_blend.Positions = New Single() {0.0, 0.2, 1.0}
        black_white_brush.InterpolationColors = color_blend
        e.Graphics.FillRectangle(black_white_brush, _
            x, y, wid, hgt)
        y += hgt + 10

        ' Make a brush that makes 50 percent of the color change
        ' in the first 20 percent of the distance, stays there
        ' until 80 percent of the distance, and then finishes
        ' in the remaining distance.
        e.Graphics.DrawString("Blend", Me.Font, Brushes.Black, x, y)
        y += 15
        Dim the_blend As New Blend(4)
        the_blend.Factors = New Single() {0.0, 0.5, 0.5, 1.0}
        the_blend.Positions = New Single() {0.0, 0.2, 0.8, 1.0}
        black_white_brush.Blend = the_blend
        e.Graphics.FillRectangle(black_white_brush, _
            x, y, wid, hgt)
        y += hgt + 10

        ' This brush's line is too short to cross the whole rectangle.
        e.Graphics.DrawString("Short", Me.Font, Brushes.Black, x, y)
        y += 15
        Dim short_brush As New _
            LinearGradientBrush( _
                New Point(x, y), New Point(x + 50, y), _
                Color.Black, Color.White)
        e.Graphics.FillRectangle(short_brush, _
            x, y, wid, hgt)
        y += hgt + 10

        x += wid + 10
        y = 10

        ' Change the brush's WrapMode.
        e.Graphics.DrawString("WrapMode = TileFlipX", Me.Font, Brushes.Black, x, y)
        y += 15
        short_brush.WrapMode = WrapMode.TileFlipX
        e.Graphics.FillRectangle(short_brush, _
            x, y, wid, hgt)
        y += hgt + 10

        ' Trangular brush.
        e.Graphics.DrawString("SetBlendTriangularShape", Me.Font, Brushes.Black, x, y)
        y += 15
        black_white_brush.SetBlendTriangularShape(0.5)
        e.Graphics.FillRectangle(black_white_brush, _
            x, y, wid, hgt)
        y += hgt + 10

        ' Sigma bell shape.
        e.Graphics.DrawString("SetSigmaBellShape", Me.Font, Brushes.Black, x, y)
        y += 15
        black_white_brush.SetSigmaBellShape(0.5, 1)
        e.Graphics.FillRectangle(black_white_brush, _
            x, y, wid, hgt)
        y += hgt + 10

        ' A diagonal brush.
        x += wid + 10
        y = 10
        wid = hgt
        e.Graphics.DrawString("Diagonal", Me.Font, Brushes.Black, x, y)
        y += 15
        Dim diag_brush As New _
            LinearGradientBrush( _
                New Point(x, y), New Point(x + wid, y + hgt), _
                Color.Black, Color.White)
        e.Graphics.FillRectangle(diag_brush, _
            x, y, wid, hgt)
        y += hgt + 10
    End Sub
End Class
