Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim app_path As String = Application.StartupPath
        If app_path.EndsWith("\bin") Then app_path = app_path.Substring(0, app_path.Length - 4)
        dlgOpenImage.InitialDirectory = app_path
    End Sub

    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        If dlgOpenImage.ShowDialog() = DialogResult.OK Then
            ' Load and display the image.
            Dim bm As New Bitmap(dlgOpenImage.FileName)
            Dim source_bm As New Bitmap(bm)
            bm.Dispose()
            picSource.Image = source_bm

            ' Arrange the controls.
            picDest.Size = picSource.Size

            ' Make the result Bitmap.
            Dim dest_bm As New Bitmap(source_bm)

            ' Invert the image's pixels.
            Dim start_time As DateTime
            Dim stop_time As DateTime
            Dim elapsed_time As TimeSpan
            start_time = Now
            InvertImage(dest_bm)
            stop_time = Now

            ' Display the results.
            picDest.Image = dest_bm

            elapsed_time = stop_time.Subtract(start_time)
            MessageBox.Show(elapsed_time.TotalSeconds.ToString("0.0000") & " seconds")
        End If
    End Sub

    Private Sub InvertImage(ByVal bm As Bitmap)
        ' Process the image's pictures.
        For y As Integer = 0 To bm.Height - 1
            For x As Integer = 0 To bm.Width - 1
                ' Get this pixel's color.
                Dim clr As Color = bm.GetPixel(x, y)

                ' Invert the color's components.
                clr = Color.FromArgb(255, _
                    255 - clr.R, _
                    255 - clr.G, _
                    255 - clr.B)

                ' Set the result pixel's color.
                bm.SetPixel(x, y, clr)
            Next x
        Next y
    End Sub
End Class
